/*
 *  complexes.h
 */

#include <stdio.h>

typedef struct comp {
  double reel;
  double imm;
} comp;

void lirec(comp *f) {
  printf("tapez part réelle et part immaginaire -- ");
  scanf("%lf",&(f->reel));
  scanf("%lf",&(f->imm));
}

void affichec(comp c) {
  if (c.reel == 0) {
    if (c.imm == 0) {
      printf("0");
    } else {
      printf("%.4lfi",c.imm);
    }
  } else {
    printf("%.4lf",c.reel);
    if(c.imm != 0) {
      if(c.imm > 0) printf("+");
      printf("%.4lfi",c.imm);
    }
  }
}

comp sommec(comp a, comp b) {
  a.reel += b.reel;
  a.imm += b.imm;
  return a;
}

comp diffc(comp a, comp b) {
  a.reel -= b.reel;
  a.imm -= b.imm;
  return a;
}

comp prodc(comp a, comp b) {
  comp c;
  c.reel = a.reel*b.reel - a.imm*b.imm;
  c.imm = a.reel*b.imm + a.imm*b.reel;
  return c;
}

// norme d'un complexe
double norme(comp a){
  return a.reel*a.reel + a.imm*a.imm;
}

// inverse d'un complexe
comp invc(comp a) {
  double n = norme(a);
  a.reel /= n;
  a.imm /= -n;
  return a;
}

comp divc(comp a, comp b) {
  return prodc(a, invc(b));
}

// puissance de complexes avec l'algorithme des carrés successifs
// calcule aussi avec un exponant negatif (mais ne fait pas
// de contrôle sur b != 0 dans ce cas)
comp puissc(comp b, int e) {
  comp res;
  res.reel = 1; // initialisation à 1
  res.imm = 0;
  if (e < 0) {
    b = invc(b);
    e = -e;
  }
  while (e != 0) {
    if(e%2 != 0) {
      res = prodc(res,b);
    }
    e /= 2;
    b = prodc(b,b);
  }
  return res;
}

unsigned int egalzeroc(comp a) {
  return (a.reel == 0)&&(a.imm == 0);
}
